#include "ScilabBridge.hxx"
/* Generated by GIWS (version 0.9.5) */
/*

Copyright 2007 INRIA

Author : Sylvestre Ledru

This software is a computer program whose purpose is to hide the complexity
of accessing Java objects/methods from C++ code.

This software is governed by the CeCILL-B license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL-B
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-B license and that you accept its terms.
*/

namespace org_scilab_modules_gui_bridge {

// Returns the current env

JNIEnv * ScilabBridge::getCurrentEnv() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread((void **) &curEnv, NULL);
return curEnv;
}
// Destructor

ScilabBridge::~ScilabBridge() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread((void **) &curEnv, NULL);

curEnv->DeleteGlobalRef(this->instance);
curEnv->DeleteGlobalRef(this->instanceClass);
}

// Constructors

ScilabBridge::ScilabBridge(JavaVM * jvm_) {
jmethodID constructObject = NULL ;
jobject localInstance ;
jclass localClass ;
const std::string construct="<init>";
const std::string param="()V";
jvm=jvm_;

JNIEnv * curEnv = getCurrentEnv();

localClass = curEnv->FindClass( this->className().c_str() ) ;
if (localClass == NULL) {
std::cerr << "Could not get the Class " << this->className() <<  std::endl;
exit(EXIT_FAILURE);
}

this->instanceClass = (jclass) curEnv->NewGlobalRef(localClass) ;
if (this->instanceClass == NULL) {
std::cerr << "Could not create a Global Ref of " << this->className() <<  std::endl;
exit(EXIT_FAILURE);
}

constructObject = curEnv->GetMethodID( this->instanceClass, construct.c_str() , param.c_str() ) ;
if(constructObject == NULL){
std::cerr << "Could not retrieve the constructor of the class " << this->className() << " with the profile : " << construct << param << std::endl;
exit(EXIT_FAILURE);
}

localInstance = curEnv->NewObject( this->instanceClass, constructObject ) ;
if(localInstance == NULL){
std::cerr << "Could not instantiate the object " << this->className() << " with the constructor : " << construct << param << std::endl;
exit(EXIT_FAILURE);
}
 
this->instance = curEnv->NewGlobalRef(localInstance) ;
if(this->instance == NULL){
std::cerr << "Could not create a new global ref of " << this->className() << std::endl;
exit(EXIT_FAILURE);
}
                /* Methods ID set to NULL */
jintnewMenuID=NULL; 
voidsetFigureAsParentjintjintID=NULL; 
voidsetParentjintjintID=NULL; 
voidsetTextjintjstringID=NULL; 


}

ScilabBridge::ScilabBridge(JavaVM * jvm_, jobject JObj) {
        jvm=jvm_;

        JNIEnv * curEnv = getCurrentEnv();

        this->instanceClass = (jclass) curEnv->NewGlobalRef(curEnv->GetObjectClass(JObj));
        if (this->instanceClass == NULL) {
               std::cerr << "Could not create a Global Ref of " << this->instanceClass <<  std::endl;
               exit(EXIT_FAILURE);
        }

        this->instance = curEnv->NewGlobalRef(JObj) ;
        if(this->instance == NULL){
               std::cerr << "Could not create a new global ref of " << this->instanceClass << std::endl;
               exit(EXIT_FAILURE);
        }
        /* Methods ID set to NULL */
        jintnewMenuID=NULL; 
voidsetFigureAsParentjintjintID=NULL; 
voidsetParentjintjintID=NULL; 
voidsetTextjintjstringID=NULL; 


}

// Generic methods


void ScilabBridge::synchronize() {
if (getCurrentEnv()->MonitorEnter(instance) != JNI_OK) {
std::cerr << "Fail to enter monitor." << std::endl;
exit(EXIT_FAILURE);
}
}


void ScilabBridge::endSynchronize() {
if ( getCurrentEnv()->MonitorExit(instance) != JNI_OK) {
std::cerr << "Fail to exit monitor." << std::endl;
exit(EXIT_FAILURE);
}
}

// Method(s)

long ScilabBridge::newMenu (JavaVM * jvm_){

JNIEnv * curEnv = NULL;
                jvm_->AttachCurrentThread((void **) &curEnv, NULL);
                jclass cls = curEnv->FindClass( className().c_str() );

jmethodID methodID = curEnv->GetStaticMethodID(cls, "newMenu", "()I" ) ;
if (methodID == NULL) {
std::cerr << "Could not access to the method " << "newMenu" << std::endl;
exit(EXIT_FAILURE);
}

                        jint res =  (jint) curEnv->CallIntMethod(cls, methodID );
                        
if (curEnv->ExceptionOccurred()) {
curEnv->ExceptionDescribe() ;
}

                        
return res;

}

void ScilabBridge::setFigureAsParent (JavaVM * jvm_, long figureID, long objID){

JNIEnv * curEnv = NULL;
                jvm_->AttachCurrentThread((void **) &curEnv, NULL);
                jclass cls = curEnv->FindClass( className().c_str() );

jmethodID methodID = curEnv->GetStaticMethodID(cls, "setFigureAsParent", "(II)V" ) ;
if (methodID == NULL) {
std::cerr << "Could not access to the method " << "setFigureAsParent" << std::endl;
exit(EXIT_FAILURE);
}

                         curEnv->CallStaticVoidMethod(cls, methodID ,figureID, objID);
                        
if (curEnv->ExceptionOccurred()) {
curEnv->ExceptionDescribe() ;
}

                        
}

void ScilabBridge::setParent (JavaVM * jvm_, long parentID, long objID){

JNIEnv * curEnv = NULL;
                jvm_->AttachCurrentThread((void **) &curEnv, NULL);
                jclass cls = curEnv->FindClass( className().c_str() );

jmethodID methodID = curEnv->GetStaticMethodID(cls, "setParent", "(II)V" ) ;
if (methodID == NULL) {
std::cerr << "Could not access to the method " << "setParent" << std::endl;
exit(EXIT_FAILURE);
}

                         curEnv->CallStaticVoidMethod(cls, methodID ,parentID, objID);
                        
if (curEnv->ExceptionOccurred()) {
curEnv->ExceptionDescribe() ;
}

                        
}

void ScilabBridge::setText (JavaVM * jvm_, long objID, char * text){

JNIEnv * curEnv = NULL;
                jvm_->AttachCurrentThread((void **) &curEnv, NULL);
                jclass cls = curEnv->FindClass( className().c_str() );

jmethodID methodID = curEnv->GetStaticMethodID(cls, "setText", "(ILjava/lang/String;)V" ) ;
if (methodID == NULL) {
std::cerr << "Could not access to the method " << "setText" << std::endl;
exit(EXIT_FAILURE);
}

jstring text_ = curEnv->NewStringUTF( text );

                         curEnv->CallStaticVoidMethod(cls, methodID ,objID, text_);
                        
if (curEnv->ExceptionOccurred()) {
curEnv->ExceptionDescribe() ;
}

                        
}

}
